<!doctype html>
<html>
  <head>
    <meta charset="utf-8" />
    <title>Call Scilab as an FMU</title>
  </head>
  <body>
    <h1>Call Scilab as an FMU</h1>
    <p>This Functional Mock-up Unit  (FMU) implements the <a href="https://fmi-standard.org/">Functional Mock-up Interface</a> for calling a Scilab script. The script is provided as a permanent variable inside the <code>modelDescription.xml</code>.</p>
    <p>A single shared Scilab instance is created for all FMUs instance due to a limitation on <a href="https://help.scilab.org/call_scilab">call_scilab</a>. The <code>canBeInstantiatedOnlyOncePerProcess</code> flag is set to alert of this limitation.</p>
    <p>All macros in the FMU's <code>resources/</code> directory is loaded at startup to develop your own code. The current directory scripts are also loaded to ease development. After this initial phase, all scripts <code>*.sce</code> in the <code>resources/</code> directory are executed.</p>
    <p>FMU's variables are stored in a Scilab list named <code>ModelVariables</code>, indexed by <code>valueReference</code>. <code>valueReference</code> should be 1-indexed to match Scilab indexes. Values are :
      <dl>
        <dt><code>fmi2SetXXX</code></dt>
        <dd>These functions update the <code>ModelVariables</code> to new values.</dd>
        <dt><code>fmi2GetXXX</code></dt>
        <dd>These functions retrieve values stored into <code>ModelVariables</code>.</dd>
      </dl>
    </p>

    <h2>Co-Simulation</h2>
    <p>On each step, a specific function named <code>fmi2DoStep</code> is called and can manipulate all variables. This function should be defined by the user and shipped within the <code>resources/</code> directory.
      <dl>
        <dt><code>ModelVariables = fmi2DoStep(ModelVariables)</code></dt>
        <dd>Inside this function, the user could use the <code>currentCommunicationPoint</code>, <code>communicationStepSize</code> and <code>noSetFMUStatePriorToCurrentPoint</code> variables.</dd>
      </dl>
    </p>

    <h2>Model Exchange</h2>
    <p>To implement a Model Exchange FMU, all these functions are optional and can be implemented to trigger a specific behavior:
      <dl>
        <dt><code>[newDiscreteStatesNeeded, terminateSimulation, nominalsOfContinuousStatesChanged, valuesOfContinuousStatesChanged, nextEventTimeDefined, nextEventTime] = fmi2NewDiscreteStates()</code></dt>
        <dd>This function can be used to change solver's behavior and enter/exit specific execution mode. See the FMI specification for a complete description.</dd>
        <dt><code>fmi2SetTime()</code></dt>
        <dd>this function call will set a new time instant named <code>time</code> in Scilab. User is free to implement a custom behavior atop.</dd>
        <dt><code>fmi2SetContinuousStates(x)</code></dt>
        <dd>this function call will set new continuous states named <code>x</code> in Scilab. User is free to implement a custom behavior atop.</dd>
        <dt><code>derivatives = fmi2GetDerivatives()</code></dt>
        <dd>this function will set state derivatives at the current time instant and for the current states named <code>derivatives</code> available to the solver.</dd>
        <dt><code>eventIndicators = fmi2GetEventIndicators()</code></dt>
        <dd>this function will make event indicators at the current time instant and for the current states named <code>eventIndicators</code> available to the solver.</dd>
        <dt><code>x = fmi2GetContinuousStates()</code></dt>
        <dd>this function will make the new continuous states named <code>x</code> available to the solver.</dd>
        <dt><code>x_nominal = fmi2GetNominalsOfContinuousStates()</code></dt>
        <dd>this function will make specific nominal values of the continuous states named <code>x_nominal</code> available to the solver.</dd>
      </dl>
    </p>
    
    <h2>Others</h2>
    <p>The user can implement any of the following functions to execute a specific behavior. These are optional and only-called if defined:
      <dl>
        <dt><code>fmi2EnterInitializationMode()</code></dt>
        <dt><code>fmi2ExitInitializationMode()</code></dt>
        <dt><code>fmi2EnterContinuousTimeMode()</code></dt>
        <dt><code>fmi2EnterEventMode()</code></dt>
        <dt><code>fmi2Terminate()</code></dt>
        <dt><code>fmi2Reset()</code></dt>
      </dl>
    </p>

  </body>
</html>
